Package: org.codehaus.groovy.classgen.asm.sc

## [Java] Class StaticInvocationWriter

- org.codehaus.groovy.classgen.asm.sc.StaticInvocationWriter

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class InvocationWriter` | `castToVargsArray, invokeClosureMethod, invokeMethod, invokeMethodOnCurrent, invokeMethodOnSuper, invokeStaticMethod`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `StaticInvocationWriter (WriterController wc)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `MethodCallExpression` | `getCurrentCall()`
    `` | `protected static boolean` | `isPrivateBridgeMethodsCallAllowed(ClassNode receiver, ClassNode caller)`
    `` | `protected void` | `loadArguments(List<Expression> argumentList, Parameter[] para)`
    `` | `protected boolean` | `makeCachedCall(Expression origin, ClassExpression sender, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean safe, boolean spreadSafe, boolean implicitThis, boolean containsSpreadExpression)`
    `` | `void` | `makeCall(Expression origin, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean safe, boolean spreadSafe, boolean implicitThis)`
    `` | `protected boolean` | `makeDirectCall(Expression origin, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean implicitThis, boolean containsSpreadExpression)`
    `` | `protected boolean` | `tryBridgeMethod(MethodNode target, Expression receiver, boolean implicitThis, TupleExpression args)` Attempts to make a direct method call on a bridge method, if it exists.
    `` | `protected boolean` | `tryBridgeMethod(MethodNode target, Expression receiver, boolean implicitThis, TupleExpression args, ClassNode thisClass)` Attempts to make a direct method call on a bridge method, if it exists.
    `` | `protected boolean` | `writeDirectMethodCall(MethodNode target, boolean implicitThis, Expression receiver, TupleExpression args)`
    `` | `void` | `writeInvokeConstructor(ConstructorCallExpression call)`
    `` | `void` | `writeInvokeMethod(MethodCallExpression call)`
    `` | `void` | `writeSpecialConstructorCall(ConstructorCallExpression call)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class InvocationWriter` | `castNonPrimitiveToBool, castToNonPrimitiveIfNecessary, coerce, finnishConstructorCall, getMethodName, loadArguments, makeArgumentList, makeCachedCall, makeCall, makeCall, makeClassForNameCall, makeDirectCall, makeSingleArgumentCall, makeUncachedCall, prepareConstructorCall, writeAICCall, writeDirectMethodCall, writeInvokeConstructor, writeInvokeMethod, writeInvokeStaticMethod, writeNormalConstructorCall, writeSpecialConstructorCall`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public StaticInvocationWriter(WriterController wc)

  - ### Method Detail

    - #### public MethodCallExpression getCurrentCall()

    - #### protected static boolean isPrivateBridgeMethodsCallAllowed(ClassNode receiver, ClassNode caller)

    - #### protected void loadArguments(List<Expression> argumentList, Parameter[] para)

    - #### @Override protected boolean makeCachedCall(Expression origin, ClassExpression sender, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean safe, boolean spreadSafe, boolean implicitThis, boolean containsSpreadExpression)

    - #### @Override public void makeCall(Expression origin, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean safe, boolean spreadSafe, boolean implicitThis)

    - #### @Override protected boolean makeDirectCall(Expression origin, Expression receiver, Expression message, Expression arguments, MethodCallerMultiAdapter adapter, boolean implicitThis, boolean containsSpreadExpression)

    - #### @Deprecated protected boolean tryBridgeMethod(MethodNode target, Expression receiver, boolean implicitThis, TupleExpression args)

      Attempts to make a direct method call on a bridge method, if it exists.

    - #### protected boolean tryBridgeMethod(MethodNode target, Expression receiver, boolean implicitThis, TupleExpression args, ClassNode thisClass)

      Attempts to make a direct method call on a bridge method, if it exists.

    - #### @Override protected boolean writeDirectMethodCall(MethodNode target, boolean implicitThis, Expression receiver, TupleExpression args)

    - #### @Override public void writeInvokeConstructor(ConstructorCallExpression call)

    - #### @Override public void writeInvokeMethod(MethodCallExpression call)

    - #### @Override public void writeSpecialConstructorCall(ConstructorCallExpression call)